% Beatles Problem Solutions

% Option 1 -- simple, but creates 1x1 structure, with 3 fields, and 4
% entries each.  It's easy to screw it up if each field does not have the
% same number of entries
beatles = struct();
beatles.name = {'John' 'Paul' 'George' 'Ringo'};
beatles.age = [ 40 68.99 58 70];
beatles.isdead = [true false true false];
beatles.name(beatles.isdead == false)
beatles.name(beatles.isdead == true)
beatles.age(beatles.isdead == true)
mean(beatles.age(beatles.isdead == true))

% Option 2 -- more complicated, but creates a 1x4 structure, each level
% having three fields.  It's easier to keep things associated with each
% other, but a tad harder to index
beatles = struct();
beatles(1).name = 'John';
beatles(2).name = 'Paul';
beatles(3).name = 'George';
beatles(4).name = 'Ringo';
beatles(1).age = 40;
beatles(2).age = 68.99;
beatles(3).age = 58;
beatles(4).age = 70;
beatles(1).isdead = true;
beatles(2).isdead = false;
beatles(3).isdead = true;
beatles(4).isdead = false;
% When indexing, need to put the results of these disparate results into
% some container
% container is a vector
[beatles.isdead] == 1
% container is a cell
{beatles.name}
% putting this together, container and indexing
{beatles([beatles.isdead] == 1).name}
% container is vector, only for dead Beatles
[beatles([beatles.isdead] == 1).age]
% now take mean
mean([beatles([beatles.isdead] == 1).age])

